import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Stack;
import java.util.List;
/**
 * Write a description of class Agen here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Agen extends Actor
{
    boolean finishedMaze = false;
    boolean createdExit = false;
    boolean win = false;
    int size = 10;
    Wall myWall[][] = new Wall[21][21];
    Cell myCell[][] = new Cell[21][21];
    Stack<Cell> myStack = new Stack<Cell>();
    int myX = 1, myY = 1;
    GreenfootImage imLeft = new GreenfootImage("kiri.png");
    GreenfootImage imRight = new GreenfootImage("kanan.png");
    GreenfootImage imUp = new GreenfootImage("atas.png");
    GreenfootImage imDown = new GreenfootImage("bawah.png");
    public GreenfootSound backgroundMusic = new GreenfootSound("Carefree.mp3");
    private boolean isGrabbed;
    int curX, curY;
    
    public Agen(){
        size = 2;
    }
    
    public Agen(int size){
        this.size = size;
    }
    
    
    /**
     * Act - do whatever the Agen wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
       if (finishedMaze==false){
            initialize();
            generateMaze();
            finishedMaze = true;
       }
       if((finishedMaze==true) && (createdExit == false)){
            myWall[1][0].setWall(false);
            myWall[size * 2 - 1][size * 2].setWall(false);
            createdExit = true;
            setImage(imDown);
            getImage().setTransparency(255);
            showMaze();
            backgroundMusic.playLoop();
       }       
       if(Greenfoot.isKeyDown("up") && win==false){
           Greenfoot.delay(3);
           moveUp();
       }
       if(Greenfoot.isKeyDown("down") && win==false){
           Greenfoot.delay(3);
           moveDown();                  
       }
       if(Greenfoot.isKeyDown("left") && win==false){
           Greenfoot.delay(3);
           moveLeft();
       }
       if(Greenfoot.isKeyDown("right") && win==false) {
           Greenfoot.delay(3);
           moveRight();
       }
       if (Greenfoot.mousePressed(this) && !isGrabbed){  
           isGrabbed = true;   
           World world = getWorld();  
           MouseInfo mi = Greenfoot.getMouseInfo();  
           curX = mi.getX();
           curY = mi.getY();  
        }  
       // check for actual dragging of the object  
       if ((Greenfoot.mouseDragged(this)) && isGrabbed)  
       {  
           MouseInfo mi = Greenfoot.getMouseInfo();
           if(mi.getX()-curX > 32){
               moveRight();
               curX=mi.getX();
           }
           if(mi.getX()-curX < -32){
               moveLeft();
               curX=mi.getX();
           }
           if(mi.getY()-curY > 32){
               moveDown();
               curY=mi.getY();
           }
           if(mi.getY()-curY < -32){
               moveUp();
               curY=mi.getY();
           }  
       }  
       // check for mouse button release  
       if (Greenfoot.mouseDragEnded(this) && isGrabbed){  
           isGrabbed = false;  
       }  
       if (myX == size * 2 - 1 && myY == size * 2){
           win = true;
           backgroundMusic.stop();
           Menang m = new Menang();
           if(size>=6) m.setImage("Menang2.png");
           getWorld().addObject(m, (size)*32+16, (size)*32+16);
           //Greenfoot.stop();
       }       
    }
    public void moveDown(){
        setImage(imDown);
        myY++;
        if (myY > size * 2)  myY = size * 2;                
        if (!isOK(myX, myY)) myY--;                    
        setLocation(getX(), myY * 32 + 16); 
    }
    public void moveUp(){
        setImage(imUp);
        myY--;
        if (myY < 1) myY = 1;
        if (!isOK(myX, myY)) myY++;
        setLocation(getX(), myY * 32 + 16);
    }
    public void moveLeft(){
        setImage(imLeft);
        myX--;
        if (myX < 1) myX = 1;
        if (!isOK(myX, myY)) myX++;
        setLocation(myX * 32 + 16, getY());
    }
    public void moveRight(){
         setImage(imRight);
         myX++;
         if (myX > size * 2 - 1)  myX = size * 2 - 1;
         if (!isOK(myX, myY)) myX--;
         setLocation(myX * 32 + 16, getY());
    }
    
    private boolean isOK(int i, int j) {
        if (myCell[i][j] != null)
            return true;
        else if (myWall[i][j] != null) {
            if (myWall[i][j].getWall() == false)
                return true;
        }
        return false;
    }
    public void initialize() {
        //inisialisasi wall
        for(int i = 0; i < (size*2+1); i++)
            for(int j = 0; j < (size*2+1); j++){
                if(j % 2 == 1){
                    if(i % 2 == 0){
                        myWall[i][j] = new Wall(i,j);
                    }
                }
                else{
                    myWall[i][j] = new Wall(i,j);
                }               
            }
        //inisialisasi Cell
        for(int i = 0; i < size; i++)
            for(int j = 0; j < size; j++){
                myCell[i*2+1][j*2+1] = new Cell(i*2+1, j*2+1, myWall[i*2+1][j*2], myWall[i*2+1][j*2+2], myWall[i*2+2][j*2+1], myWall[i*2][j*2+1]);
            }
        
        for(int i = 0; i < size; i++)
            for(int j = 0; j < size; j++){
                //north
                if((j-1)>=0){
                    myCell[i*2+1][j*2+1].setNorthCell(myCell[i*2+1][(j-1)*2+1]);
                }
                //south
                if((j+1)<size){
                    myCell[i*2+1][j*2+1].setSouthCell(myCell[i*2+1][(j+1)*2+1]);
                }
                //east
                if((i+1)<size){
                    myCell[i*2+1][j*2+1].setEastCell(myCell[(i+1)*2+1][j*2+1]);
                }
                //west
                if((i-1)>=0){
                    myCell[i*2+1][j*2+1].setWestCell(myCell[(i-1)*2+1][j*2+1]);
                }
            }
    }
    public void setSize(int size) {
        this.size = size;
    }
    public void generateMaze() {
        int currentX = size-1, currentY = size-1;
        myCell[currentX*2+1][currentY*2+1].setVisited();
        while(isAllVisited()!=true){
            if(myCell[currentX*2+1][currentY*2+1].isNeighAllVisited()!=true){
                int temp = myCell[currentX*2+1][currentY*2+1].getRandomNeigh();
                myStack.push(myCell[currentX*2+1][currentY*2+1]);
                //north
                if(temp==0){
                    myWall[currentX*2+1][currentY*2].setWall(false);
                    currentY = currentY - 1;
                }
                //south
                else if(temp==1){
                    myWall[currentX*2+1][currentY*2+2].setWall(false);
                    currentY = currentY + 1;
                }
                //east
                else if(temp==2){
                    myWall[currentX*2+2][currentY*2+1].setWall(false);
                    currentX = currentX + 1;
                }
                //west
                else if(temp==3){
                    myWall[currentX*2][currentY*2+1].setWall(false);
                    currentX = currentX - 1;
                }
                myCell[currentX*2+1][currentY*2+1].setVisited();
            }
            else if(myStack.isEmpty()!=true){
                Cell tempCell = (Cell) myStack.pop();
                currentX = (tempCell.getX()-1)/2;
                currentY = (tempCell.getY()-1)/2;
            }
            if(size<=4) Greenfoot.delay(4);
            else if(size<=6) Greenfoot.delay(3);
            else if(size<=8) Greenfoot.delay(2);
            else if(size<=20) Greenfoot.delay(1);
            showMaze();
        }           
    }
    public boolean isAllVisited(){
        for(int i = 0; i < size; i++)
           for(int j = 0; j < size; j++){
               if(myCell[i*2+1][j*2+1].getVisited()==false) return false;
           } 
        return true;
    }
    public void showMaze(){
        getWorld().removeObjects(getWorld().getObjects(Tembok.class));                
        for (int i = 0; i < (size * 2 + 1); i++) {
            for (int j = 0; j < (size * 2 + 1); j++) {
                if (j % 2 == 1) {
                    if (i % 2 == 0) {
                        if (myWall[i][j].getWall() == true) {
                            getWorld().addObject(new Tembok(), i * 32 + 16, j * 32 + 16);
                        }
                    } 
                } else {
                    if (myWall[i][j].getWall() == true) {
                        getWorld().addObject(new Tembok(), i * 32 + 16, j * 32 + 16);
                    }
                }
            }
        }
    }
}
