import java.util.Random;
/**
 * Write a description of class Cell here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Cell  
{
    // instance variables - replace the example below with your own
    private int posX = 0;
    private int posY = 0;
    private Wall northWall, southWall, eastWall, westWall;
    private Cell nCell, sCell, eCell, wCell;
    private boolean visited = false;

    /**
     * Constructor for objects of class Cell
     */
    public Cell(int x, int y){
		posX = x;
		posY = y;
	}
	
	public Cell(int x, int y, Wall north, Wall south, Wall east, Wall west){
		posX = x;
		posY = y; 
		northWall = north;
		southWall = south;
		eastWall = east;
		westWall = west;
		nCell = null;
		sCell = null;
		eCell = null;
		wCell = null;
	}
	public int getX(){
		return posX;
	}
	
	public int getY(){
		return posY;
	}
	
	public void setNorthWall(Wall n){
		northWall = n;
	}
	
	public void setSouthWall(Wall s){
		southWall = s;
	}
	
	public void setEastWall(Wall e){
		eastWall = e;
	}
	
	public void setWestWall(Wall w){
		westWall = w;
	}
		
	public Wall getNorthWall(){
		return northWall;
	}
	
	public Wall getSouthWall(){
		return southWall;
	}
	
	public Wall getEastWall(){
		return eastWall;
	}
	
	public Wall getWestWall(){
		return westWall;
	}
	public void setNorthCell(Cell n){
		nCell = n;
	}
	
	public void setSouthCell(Cell s){
		sCell = s;
	}
	
	public void setEastCell(Cell e){
		eCell = e;
	}
	
	public void setWestCell(Cell w){
		wCell = w;
	}
	
	public Cell getNorthCell(){
		return nCell;
	}
	
	public Cell getSouththCell(){
		return sCell;
	}
	
	public Cell getEastCell(){
		return eCell;
	}
	
	public Cell getWestCell(){
		return wCell;
	}
	
	public void setVisited(){
		visited = true;
	}
	
	public boolean getVisited(){
		return visited;
	}
	public boolean isNeighAllVisited(){
		if (nCell != null){
			if(nCell.getVisited() == false) return false; 
		}
		if (sCell != null){
			if(sCell.getVisited() == false) return false; 
		}
		if (eCell != null){
			if(eCell.getVisited() == false) return false; 
		}
		if (wCell != null){
			if(wCell.getVisited() == false) return false; 
		}		
		return true;
	}
	public int getRandomNeigh(){	
	    Random rn = new Random();
		while(true){
			int i = rn.nextInt(4);
			if(i==0){
				if (nCell != null){
					if(nCell.getVisited() == false) return 0;
				}
			}
			if(i==1){
				if (sCell != null){
					if(sCell.getVisited() == false) return 1;
				}
			}
			if(i==2){
				if (eCell != null){
					if(eCell.getVisited() == false) return 2;
				}
			}
			if(i==3){
				if (wCell != null){
					if(wCell.getVisited() == false) return 3;
				}
			}
		}		
	}
}